﻿/******************************************
	Copyright © 2011 by Ait El Haj Mustapha (mgraph)
	All rights reserved.
	http://www.mmfiles.com/users/mgraph/
*******************************************/

package com
{
	import fl.transitions.Tween;
	import fl.transitions.easing.*;
	import flash.display.*;
	import flash.events.*;
	import flash.net.navigateToURL;
	import flash.net.URLRequest;
	import flash.geom.*;
	import com.caurina.transitions.Tweener;
	import flash.net.URLLoader;

	public class Profil3d extends MovieClip
	{
		private var val:Number = 0;
		private var back:Number = 0;
		private var listNom:Array;
		private var listPres:Array;
		private var listImg:Array;
		private var lastPos:Number;
		private var listPos:Array;
		private var mm:Number = 0;
		private var charge:XML;
		private var listMc:Array;
		private var total:Number;
		private var container:MovieClip;
		private var nm:Number = 0;
		
		
		public function Profil3d(){
			addEventListener(Event.ADDED_TO_STAGE, init);
			}
		private function init(e:Event):void{
			root.transform.perspectiveProjection.projectionCenter = new Point(1,-30);
			var fichier:String;
			if(root.loaderInfo.parameters.monconfig){
				fichier = root.loaderInfo.parameters.monconfig;
				}
				else{
					fichier = "config.xml";
				}
			var xmlLoader:URLLoader = new URLLoader;
			var xmlReq:URLRequest = new URLRequest(fichier);
			xmlLoader.addEventListener(Event.COMPLETE,loadXML);
			xmlLoader.load(xmlReq);
			}
		private function loadXML(e:Event)
		{
			charge = new XML(e.target.data);
			listMc = new Array  ;
			listPres = new Array;
			listNom = new Array;
			listImg = new Array;
			container = new MovieClip;
			container.buttonMode = true;
			container.addEventListener(MouseEvent.MOUSE_DOWN,moveNext);

			total = charge.images.image.length();
			for (var n=0; n<total; n++)
			{
				listNom.push(charge.images.image[n].@nom);
				listPres.push(charge.images.image[n].@pres);
				listImg.push(charge.images.image[n].@img);
			}
			container.x = 80;
			container.y = 147;
			container.rotationX = -5;
			container.rotationY = -15;
			container.rotationZ = -0.05;
			addChild(container);
			
			inter_txt.alpha = 0;
			Tweener.addTween(inter_txt,{alpha:1,time:3,transition:"easeOut"});
			inter_txt.htmlText = "<b>"+listNom[0] + "</b><br/><br/>" + listPres[0];
			
			var img:MovieClip = new MovieClip;
			img.vars = 0;
			listMc[0] = img;
			container.addChild(img);
			var imgLoader:Loader = new Loader;
			imgLoader.load(new URLRequest(listImg[0]));
			imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,loadNext);
			imgLoader.y = -95;
			img.addChild(imgLoader);
		
		}
		private function loadNext(e:Event):void{
			if(nm < (total-1)){
				nm++;
				var img:MovieClip = new MovieClip;
				img.vars = nm;
				listMc[nm] = img;
				container.addChild(img);
				var imgLoader:Loader = new Loader;
				imgLoader.load(new URLRequest(listImg[nm]));
				imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,loadNext);
				imgLoader.y = -95;
				img.addChild(imgLoader);
				swap(listMc[nm]);
				Tweener.addTween(listMc[nm],{rotationX:(-10*(nm)),time:2,transition:"easeOut"});
			}
			else{
				/*for (var b=0; b<total; b++){
					swap(listMc[b]);
					Tweener.addTween(listMc[b],{rotationX:(-10*(b+1)),time:2,transition:"easeOut"});
					}*/
				}
			}
		private function btnEvent(me:MouseEvent):void
		{
			switch (me.type)
			{
				case "mouseOver" :
					me.currentTarget.alpha = 0.8;
					break;
				case "mouseOut" :
					me.currentTarget.alpha = 1;
					break;
				case "mouseDown" :
					navigateToURL(new URLRequest(charge.lien));
					break;
			}
		}
		private function tracer(me:MouseEvent):void{
			container.rotationX = stage.mouseX;
			container.rotationY = stage.mouseY;
			container.rotationZ = stage.mouseX /100;
			trace("-----------------------------------");
			trace("Z:"+container.rotationZ);
			trace("X:"+container.rotationX);
			trace("Y:"+container.rotationY);
			
			}
		private function moveNext(me:MouseEvent)
		{
			if(val == (total-1)){
				val = 0;
				trace("before : "+listMc.length);
				listMc.splice(0,(total-1));
				trace("after : "+listMc.length);
				//trace("array : "+listMc);
				}
				inter_txt.htmlText = "<b>"+listNom[val+1] + ":</b><br/><br/>" + listPres[val+1];
				inter_txt.alpha = 0;
				lastPos = listMc[val].rotationX;
				Tweener.addTween(inter_txt,{alpha:1,time:1,transition:"easeOut"});
				Tweener.addTween(listMc[val],{rotationX:68,time:0.5,transition:"easeOut",onComplete:hideCurrent,onCompleteParams:[val]});
				for (var i=(val+1); i<listMc.length; i++)
				{
					//trace("i:"+(-10*((i-1)-val)));
					Tweener.addTween(listMc[i],{rotationX:(-10*((i-1)-val)),time:1,transition:"easeOut"});
				}
				val++;
		}
		private function hideCurrent(_val):void
		{
			var _targ:MovieClip = MovieClip(listMc[_val]);
			swap(_targ);
			_targ.rotationX = -85;
			_targ.alpha = 0;
			Tweener.addTween(_targ,{alpha:1,time:1,transition:"easeOut"});
			listMc.push(_targ);
			listNom.push(listNom[_val]);
			listPres.push(listPres[_val]);

		}
		private function swap(_targ):void
		{
			container.setChildIndex(MovieClip(_targ),0);
		}
	}
}